#include "String_int_dict.h"

#include <catch.h>
#include <string>

using namespace std;
using namespace dictionary;

TEST_CASE("Member_empty")
{
    String_int_dict dict;
    CHECK_FALSE(dict.has_key("a"));
}

TEST_CASE("Find_not_found_is_null")
{
    String_int_dict dict;
    CHECK(dict.find("a") == nullptr);
}

TEST_CASE("Insert_first_element_then_lookup")
{
    String_int_dict dict;
    dict.insert("b", 5);

    CHECK_FALSE(dict.has_key("a"));
    CHECK(dict.has_key("b"));
    CHECK(5 == dict["b"]);
}

TEST_CASE("Insert_several")
{
    String_int_dict dict;
    dict.insert("d", 4);
    dict.insert("b", 2);
    dict.insert("a", 1);

    CHECK(dict.has_key("a"));
    CHECK(dict.has_key("b"));
    CHECK_FALSE(dict.has_key("c"));
    CHECK(dict.has_key("d"));
    CHECK_FALSE(dict.has_key("e"));
    CHECK_FALSE(dict.has_key("f"));
    CHECK_FALSE(dict.has_key("g"));

    dict.insert("c", 3);
    dict.insert("f", 6);
    dict.insert("e", 5);
    dict.insert("g", 7);

    CHECK(dict.has_key("a"));
    CHECK(dict.has_key("b"));
    CHECK(dict.has_key("c"));
    CHECK(dict.has_key("d"));
    CHECK(dict.has_key("e"));
    CHECK(dict.has_key("f"));
    CHECK(dict.has_key("g"));
    CHECK_FALSE(dict.has_key(""));
    CHECK_FALSE(dict.has_key("ax"));
    CHECK_FALSE(dict.has_key("bx"));
    CHECK_FALSE(dict.has_key("cx"));
    CHECK_FALSE(dict.has_key("dx"));
    CHECK_FALSE(dict.has_key("ex"));
    CHECK_FALSE(dict.has_key("fx"));
    CHECK_FALSE(dict.has_key("gx"));

    CHECK(1 == dict["a"]);
    CHECK(2 == dict["b"]);
    CHECK(3 == dict["c"]);
    CHECK(4 == dict["d"]);
    CHECK(5 == dict["e"]);
    CHECK(6 == dict["f"]);
    CHECK(7 == dict["g"]);

    CHECK(dict.find("h") == nullptr);

    int* e = dict.find("e");
    CHECK(5 == *e);

    *e = 105;
    CHECK(105 == dict["e"]);

    CHECK(0 == dict["h"]);
}

